#!/usr/bin/perl

# Argumentos
# r1, r2, a, k

die "Args: r1 r2 a k\n" if $#ARGV!=3;

$r1 = $ARGV[0];
$r2 = $ARGV[1];
$a  = $ARGV[2];
$k  = $ARGV[3];

if( $r1 > $r2 ) {
	$tmp = $r1;
	$r1 = $r2;
	$r2 = $tmp;
}

# inicializacin
$theta = 2*3.141592654/$k;

$pi_x = 0;
$pi_z = $r1;

$pipx = 0;
$pipz = $r2;

# Calculamos la normal
$phi = atan2( $r2-$r1, $a/2 );

$sinphi = sin( $phi );
$cosphi = cos( $phi );

print "FACES $k\n";

for( $i=0; $i<$k; $i++ ){

	# Calculamos los puntos en i+1
	$ang = (($i+1)%$k)*$theta;

	
	$pnew_x = $r1*sin($ang);
	$pnew_z = $r1*cos($ang);

	$pnewpx = $r2*sin($ang);
	$pnewpz = $r2*cos($ang);

	$ang = ($i+0.5)*$theta;
	$nx = sin($ang)*$cosphi;
	$ny = $sinphi; 
	$nz = cos($ang)*$cosphi;

	print "#\n";
	print "NORMAL $nx $ny $nz\n";
	print "COLOR 255 10 10\n";
	print "POLYGON 4\n";
	$alt = $a/2;
	print "$pnew_x $alt $pnew_z\n"; 
	print "$pi_x $alt $pi_z\n"; 
	print "$pipx -$alt $pipz\n"; 
	print "$pnewpx -$alt $pnewpz\n"; 

	$pi_x = $pnew_x;
	$pi_z = $pnew_z;

	$pipx = $pnewpx;
	$pipz = $pnewpz;
}
